//
// Created by illyum on 9/15/2024.
//

#pragma once

#include <pch.hpp>
#include "Logger.hpp"

namespace ICEngine {
	class ICEApplication {
	public:
		ICEApplication() {
		}

		virtual ~ICEApplication() {
		}

		virtual void Run() = 0;

		using TerminationHandler = std::function<void(const std::string &)>;

		static void SetTerminationHandler(TerminationHandler handler);

		static void HandleFatalError(const std::string &message);

	private:
		static TerminationHandler customHandler;

		static void DefaultTerminationHandler(const std::string &message);
	};

	void StartApplication();

	// Application-specific function that will be defined by the user
	extern ICEApplication *CreateICEApplication();
}
